@echo off
c:

rem -- If you would like a tutorial on JAXB, see "Data binding with JAXB"  
rem -- presented by IBM developerWorks.  It is available at 
rem -- http://www.ibm.com/developerWorks.  Just search for
rem -- "Data binding with JAXB".  
rem -- 
rem -- The same tutorial is made available to you in PDF
rem -- format here: \tutorial\Data_Binding_With_JAXB.pdf.

rem -- Note:  If you are using JDK 1.4.x, the JAXP (not JAXB)
rem -- classes are built into the JRE.  You will need to 
rem -- override these by moving the files unpacked by the java
rem -- Web Services Developers pack (JWSDP) installation into
rem -- [JWSDP_HOME]\jaxp-1.2.2\lib\endorsed to
rem -- [JAVA_HOME]\jre\lib\endorsed.
rem -- 
rem -- For your convenience, the [JWSDP_HOME]\jaxp-1.2.2\lib\endorsed
rem -- jar files are made available to you under the folder 
rem -- \jwsdp\jaxp\endorsed
rem -- 
set JAVA_HOME=C:\java\j2sdk1.4.2

rem -- After installing JWSDP, modify the following to reflect
rem -- your environment.  The required jar files are also made 
rem -- available to you in the \lib directory:
rem -- 
set JWSDP_HOME=C:\java\jwsdp-1.2
set JWSDP_SHARED=%JWSDP_HOME%\jwsdp-shared\lib
set JAXB_HOME=%JWSDP_HOME%\jaxb
set JAXB_LIB=%JAXB_HOME%\lib


echo ====================================
echo =========== SETTING PATH ===========
echo ====================================

echo :: PATH ::
set path=%PATH%;%JAVA_HOME%\bin;

echo ====================================
echo =========== :: PATH :: =============
echo ====================================
echo 
echo %PATH%

echo
echo
echo ====================================
echo ======== UPDATING CLASSPATH ========
echo ====================================

echo
set classpath=.;%JWSDP_SHARED%\xsdlib.jar;%JWSDP_SHARED%\namespace.jar;%JWSDP_SHARED%\relaxngDatatype.jar;%JAXB_LIB%\jaxb-xjc.jar;%JAXB_LIB%\jaxb-api.jar;%JAXB_LIB%\jaxb-impl.jar;%JAXB_LIB%\jaxb-libs.jar;%JAVA_HOME%\lib\tools.jar

echo ====================================
echo ======== :: CLASSPATH :: ===========
echo ====================================
echo 
echo %CLASSPATH%

rem -- use the following to determine what JAXB schema compilation options are available:
rem -- java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar -help

java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar EGrantsHeaderSchema20030612V010.xsd -p gov.grants.system.header -nv
javac .\gov\grants\system\header\*.java
javac .\gov\grants\system\header\impl\*.java
javac .\gov\grants\system\header\impl\runtime\*.java

rem -- use EGrantsSF424AwardingAgencySchema20030612V010.xsd below
rem -- java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar EGrantsSF424SubmittingOrganizationSchema20030612V010.xsd -p gov.grants.sf424  -nv
rem -- javac .\gov\grants\sf424\*.java
rem -- javac .\gov\grants\sf424\impl\*.java
rem -- javac .\gov\grants\sf424\impl\runtime\*.java

rem -- 'redefine' is not currently supported in JAXB
rem -- EGrantsSF424AwardingAgencySchema20030612V010.xsd is the
rem -- same as EGrantsSF424SubmittingOrganizationSchema20030612V010.xsd 
rem -- with the addition of two fields. 
rem -- 
rem -- The Awarding Agency schema now 'officially' uses xsd:extension
rem -- versus xsd:redefine, which is not widely supported  
rem -- 
java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar EGrantsSF424AwardingAgencySchema20030612V010.xsd -p gov.grants.sf424  -nv -extension
javac .\gov\grants\sf424\*.java
javac .\gov\grants\sf424\impl\*.java
javac .\gov\grants\sf424\impl\runtime\*.java

java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar EGrantsSF424ASchema20030612V010.xsd -p gov.grants.sf424a -nv
javac .\gov\grants\sf424a\*.java
javac .\gov\grants\sf424a\impl\*.java
javac .\gov\grants\sf424a\impl\runtime\*.java

java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar EGrantsSF424BSchema20030612V010.xsd -p gov.grants.sf424b -nv
javac .\gov\grants\sf424b\*.java
javac .\gov\grants\sf424b\impl\*.java
javac .\gov\grants\sf424b\impl\runtime\*.java

java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar EGrantsSF424CSchema20030612V010.xsd -p gov.grants.sf424c -nv
javac .\gov\grants\sf424c\*.java
javac .\gov\grants\sf424c\impl\*.java
javac .\gov\grants\sf424c\impl\runtime\*.java

java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar EGrantsSF424DSchema20030612V010.xsd -p gov.grants.sf424d -nv
javac .\gov\grants\sf424d\*.java
javac .\gov\grants\sf424d\impl\*.java
javac .\gov\grants\sf424d\impl\runtime\*.java

java -jar C:\java\jwsdp-1.2\jaxb\lib\jaxb-xjc.jar EGrantsFooterSchema20030612V010.xsd -p gov.grants.system.footer -nv
javac .\gov\grants\system\footer\*.java
javac .\gov\grants\system\footer\impl\*.java
javac .\gov\grants\system\footer\impl\runtime\*.java

cmd