/**
 *  @filename: DBUtils.java
 *  @create date: 2003-07-14
 *  @author: Grants.gov - Dan Dumitru
 *
 *  @version 1.0.0
 *  @revision date:
 *
 */

package gov.grants.utility;

// Sun
import java.sql.*;

public final class DBUtils {

	
    public static final String JDBC_CLASS = "org.gjt.mm.mysql.Driver";
    public static final String JDBC_URL = "jdbc:mysql://localhost/grants_gov";

    private DBUtils() {}

    /************************
     *
     *  :: UTILITY METHODS ::
     *
     ************************/

    /**
     *  Returns a connection to the mySql database
     *
     */
	public static Connection getConnection()
	{
		Connection conn=null;
		try
		{
			Driver driver = (Driver)Class.forName( JDBC_CLASS ).newInstance();
			conn = driver.connect( JDBC_URL, null );
		}
		catch (Exception f) {System.out.println("Exception getting connection: " + f.getMessage() ); }
		return conn;
	}
 
}// DBUtils