/*
 * Created on Jul 17, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.grants.xmlToDB.dao;

import java.util.*;
import java.sql.*;
import gov.grants.xmlToDB.valueobject.*;

/**
 * @author dxia
 *
 * Sf424a_otherinfo Data Access Object (DAO).
 * This class contains all database handling that is needed to
 * permanently store and retrieve Sf424a_otherinfo object instances.
 */



public class Sf424a_otherinfoDao {


    /**
     * load-method. This will load valueObject contents from database using
     * Primary-Key as identifier. Upper layer should use this so that valueObject
     * instance is created and only primary-key should be specified. Then call
     * this method to complete other persistent information. This method will
     * overwrite all other fields except primary-key and possible runtime variables.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be loaded.
     *                     Primary-key field must be set for this to work properly.
     */
    public void load(Connection conn, Sf424a_otherinfo valueObject) throws SQLException {

          String sql = "SELECT * FROM Sf424a_otherinfo WHERE OtherInfoIndex = ?";
          PreparedStatement stmt = null;

          try {
               stmt = conn.prepareStatement(sql);

               stmt.setInt(1, valueObject.getOtherInfoIndex());
               singleQuery(conn, stmt, valueObject);

          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * LoadAll-method. This will read all contents from database table and
     * build an Vector containing valueObjects. Please note, that this method
     * will consume huge amounts of resources if table has lot's of rows.
     * This should only be used when target tables have only small amounts
     * of data.
     *
     * @param conn         This method requires working database connection.
     */
    public List loadAll(Connection conn) throws SQLException {

          List searchResults;

          String sql = "SELECT * FROM Sf424a_otherinfo ";
          sql = sql + "ORDER BY OtherInfoIndex ";

          searchResults = listQuery(conn, conn.prepareStatement(sql));


          return searchResults;
    }



    /**
     * create-method. This will create new row in database according to supplied
     * valueObject contents. Make sure that values for all NOT NULL columns are
     * correctly specified. Also, if this table does not use automatic surrogate-keys
     * the primary-key must be specified. After INSERT command this method will
     * read the generated primary-key back to valueObject if automatic surrogate-keys
     * were used.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be created.
     *                     If automatic surrogate-keys are not used the Primary-key
     *                     field must be set for this to work properly.
     */
    public void create(Connection conn, Sf424a_otherinfo valueObject) throws SQLException {

          String sql = "INSERT INTO Sf424a_otherinfo ( OtherInfoIndex, FormVersionIdentifier, Grants_govTrackingNumber, OtherDirectChargesExplanation" +
          ", OtherIndirectChargesExplanation, Remarks) VALUES (?, ?, ?, ?, ?, ? )";
          PreparedStatement stmt = null;

          try {
               stmt = conn.prepareStatement(sql);

               stmt.setInt(1, valueObject.getOtherInfoIndex());
               stmt.setString(2, valueObject.getFormVersionIdentifier());
               stmt.setString(3, valueObject.getGrants_govTrackingNumber());
               stmt.setString(4, valueObject.getOtherDirectChargesExplanation());
               stmt.setString(5, valueObject.getOtherIndirectChargesExplanation());
               stmt.setString(6, valueObject.getRemarks());
               int rowcount = databaseUpdate(conn, stmt);
               if (rowcount != 1) {
                    //System.out.println("PrimaryKey Error when updating DB!");
                    throw new SQLException("PrimaryKey Error when updating DB!");
               }

          } finally {
              if (stmt != null)
                  stmt.close();
          }



    }


    /**
     * save-method. This method will save the current state of valueObject to database.
     * Save can not be used to create new instances in database, so upper layer must
     * make sure that the primary-key is correctly specified. Primary-key will indicate
     * which instance is going to be updated in database.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be saved.
     *                     Primary-key field must be set for this to work properly.
     */
    public void save(Connection conn, Sf424a_otherinfo valueObject) throws SQLException {

          String sql = "UPDATE Sf424a_otherinfo SET OtherInfoIndex = ?, FormVersionIdentifier = ?, Grants_govTrackingNumber = ?" +
          ", OtherDirectChargesExplanation = ?, OtherIndirectChargesExplanation = ?, Remarks = ? WHERE OtherInfoIndex = ?";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);

              stmt.setInt(1, valueObject.getOtherInfoIndex());
              stmt.setString(2, valueObject.getFormVersionIdentifier());
              stmt.setString(3, valueObject.getGrants_govTrackingNumber());
              stmt.setString(4, valueObject.getOtherDirectChargesExplanation());
              stmt.setString(5, valueObject.getOtherIndirectChargesExplanation());
              stmt.setString(6, valueObject.getRemarks());
              stmt.setInt(7, valueObject.getOtherInfoIndex());

              int rowcount = databaseUpdate(conn, stmt);
              if (rowcount != 1) {
                   //System.out.println("PrimaryKey Error when updating DB!");
                   throw new SQLException("PrimaryKey Error when updating DB!");
              }
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * delete-method. This method will remove the information from database as identified by
     * by primary-key in supplied valueObject. Once valueObject has been deleted it can not
     * be restored by calling save. Restoring can only be done using create method but if
     * database is using automatic surrogate-keys, the resulting object will have different
     * primary-key than what it was in the deleted object.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance to be deleted.
     *                     Primary-key field must be set for this to work properly.
     */
    public void delete(Connection conn, Sf424a_otherinfo valueObject) throws SQLException {

          String sql = "DELETE FROM Sf424a_otherinfo WHERE OtherInfoIndex = ?";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);

               stmt.setInt(1, valueObject.getOtherInfoIndex());

              int rowcount = databaseUpdate(conn, stmt);
              if (rowcount != 1) {
                   //System.out.println("PrimaryKey Error when updating DB!");
                   throw new SQLException("PrimaryKey Error when updating DB!");
              }
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * deleteAll-method. This method will remove all information from the table that matches
     * this Dao and ValueObject couple. This should be the most efficient way to clear table.
     * Once deleteAll has been called, no valueObject that has been created before can be
     * restored by calling save. Restoring can only be done using create method but if database
     * is using automatic surrogate-keys, the resulting object will have different primary-key
     * than what it was in the deleted object. (Note, the implementation of this method should
     * be different with different DB backends.)
     *
     * @param conn         This method requires working database connection.
     */
    public void deleteAll(Connection conn) throws SQLException {

          String sql = "DELETE FROM Sf424a_otherinfo";
          PreparedStatement stmt = null;

          try {
              stmt = conn.prepareStatement(sql);
              int rowcount = databaseUpdate(conn, stmt);
          } finally {
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * coutAll-method. This method will return the number of all rows from table that matches
     * this Dao. The implementation will simply execute "select count(primarykey) from table".
     * If table is empty, the return value is 0. This method should be used before calling
     * loadAll, to make sure table has not too many rows.
     *
     * @param conn         This method requires working database connection.
     */
    public int countAll(Connection conn) throws SQLException {

          String sql = "SELECT count(OtherInfoIndex) FROM Sf424a_otherinfo";
          PreparedStatement stmt = null;
          ResultSet result = null;
          int allRows = 0;

          try {
              stmt = conn.prepareStatement(sql);
              result = stmt.executeQuery();

              if (result.next())
                  allRows = result.getInt(1);
          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }
          return allRows;
    }


    /**
     * searchMatching-Method. This method provides searching capability to
     * get matching valueObjects from database. It works by searching all
     * objects that match permanent instance variables of given object.
     * Upper layer should use this by setting some parameters in valueObject
     * and then  call searchMatching. The result will be 0-N objects in vector,
     * all matching those criteria you specified. Those instance-variables that
     * have NULL values are excluded in search-criteria.
     *
     * @param conn         This method requires working database connection.
     * @param valueObject  This parameter contains the class instance where search will be based.
     *                     Primary-key field should not be set.
     */
    public List searchMatching(Connection conn, Sf424a_otherinfo valueObject) throws SQLException {

          List searchResults;

          boolean first = true;
          StringBuffer sql = new StringBuffer("SELECT * FROM Sf424a_otherinfo WHERE 1=1 ");
          if (valueObject.getOtherInfoIndex() != 0) {
              if (first) { first = false; }
              sql.append("AND OtherInfoIndex = ").append(valueObject.getOtherInfoIndex()).append(" ");
          }

          if (valueObject.getFormVersionIdentifier() != null) {
              if (first) { first = false; }
              sql.append("AND FormVersionIdentifier LIKE '").append(valueObject.getFormVersionIdentifier()).append("%' ");
          }

          if (valueObject.getGrants_govTrackingNumber() != null) {
              if (first) { first = false; }
              sql.append("AND Grants_govTrackingNumber LIKE '").append(valueObject.getGrants_govTrackingNumber()).append("%' ");
          }

          if (valueObject.getOtherDirectChargesExplanation() != null) {
              if (first) { first = false; }
              sql.append("AND OtherDirectChargesExplanation LIKE '").append(valueObject.getOtherDirectChargesExplanation()).append("%' ");
          }

          if (valueObject.getOtherIndirectChargesExplanation() != null) {
              if (first) { first = false; }
              sql.append("AND OtherIndirectChargesExplanation LIKE '").append(valueObject.getOtherIndirectChargesExplanation()).append("%' ");
          }

          if (valueObject.getRemarks() != null) {
              if (first) { first = false; }
              sql.append("AND Remarks LIKE '").append(valueObject.getRemarks()).append("%' ");
          }

          sql.append("ORDER BY OtherInfoIndex ");

          // Prevent accidential full table results.
          // Use loadAll if all rows must be returned.
          if (first)
               searchResults = new Vector();
          else
               searchResults = listQuery(conn, conn.prepareStatement(sql.toString()));

          return searchResults;
    }


    /**
     * getDaogenVersion will return information about
     * generator which created these sources.
     */
    public String getDaogenVersion() {
        return "DaoGen version 0.99.0";
    }


    /**
     * databaseUpdate-method. This method is a helper method for internal use. It will execute
     * all database handling that will change the information in tables. SELECT queries will
     * not be executed here however. The return value indicates how many rows were affected.
     * This method will also make sure that if cache is used, it will reset when data changes.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     */
    protected int databaseUpdate(Connection conn, PreparedStatement stmt) throws SQLException {

          int result = stmt.executeUpdate();
          return result;
    }



    /**
     * databaseQuery-method. This method is a helper method for internal use. It will execute
     * all database queries that will return only one row. The resultset will be converted
     * to valueObject. If no rows were found, an exception will be thrown.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     * @param valueObject  Class-instance where resulting data will be stored.
     */
    protected void singleQuery(Connection conn, PreparedStatement stmt, Sf424a_otherinfo valueObject) throws SQLException {

          ResultSet result = null;

          try {
              result = stmt.executeQuery();

              if (result.next()) {
                   valueObject.setOtherInfoIndex(result.getInt("OtherInfoIndex"));
                   valueObject.setFormVersionIdentifier(result.getString("FormVersionIdentifier"));
                   valueObject.setGrants_govTrackingNumber(result.getString("Grants_govTrackingNumber"));
                   valueObject.setOtherDirectChargesExplanation(result.getString("OtherDirectChargesExplanation"));
                   valueObject.setOtherIndirectChargesExplanation(result.getString("OtherIndirectChargesExplanation"));
                   valueObject.setRemarks(result.getString("Remarks"));
              } else {
                    //System.out.println("Sf424a_otherinfo Object Not Found!");
                    throw new SQLException("Sf424a_otherinfo Object Not Found!");
              }
          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }
    }


    /**
     * databaseQuery-method. This method is a helper method for internal use. It will execute
     * all database queries that will return multiple rows. The resultset will be converted
     * to the List of valueObjects. If no rows were found, an empty List will be returned.
     *
     * @param conn         This method requires working database connection.
     * @param stmt         This parameter contains the SQL statement to be excuted.
     */
    protected List listQuery(Connection conn, PreparedStatement stmt) throws SQLException {

          Vector searchResults = new Vector();
          ResultSet result = null;

          try {
              result = stmt.executeQuery();

              while (result.next()) {
                   Sf424a_otherinfo temp = new Sf424a_otherinfo();
                   temp.setOtherInfoIndex(result.getInt("OtherInfoIndex"));
                   temp.setFormVersionIdentifier(result.getString("FormVersionIdentifier"));
                   temp.setGrants_govTrackingNumber(result.getString("Grants_govTrackingNumber"));
                   temp.setOtherDirectChargesExplanation(result.getString("OtherDirectChargesExplanation"));
                   temp.setOtherIndirectChargesExplanation(result.getString("OtherIndirectChargesExplanation"));
                   temp.setRemarks(result.getString("Remarks"));
                   searchResults.add(temp);
              }

          } finally {
              if (result != null)
                  result.close();
              if (stmt != null)
                  stmt.close();
          }

          return (List)searchResults;
    }



}

